# - Try to find OpenGL
# Once done this will define
#  
#  OPENGL_FOUND        - system has OpenGL
#  OPENGL_INCLUDE_DIR  - the GL include directory
#  OPENGL_LIBRARIES    - Link these to use OpenGL

IF (WIN32)
	IF (CYGWIN)
		FIND_PATH    ( OPENGL_INCLUDE_DIR GL/gl.h )
		FIND_LIBRARY ( OPENGL_LIBRARIES opengl32 )
	ELSE (CYGWIN)
		IF(BORLAND)
			SET (OPENGL_LIBRARIES import32 CACHE STRING "OpenGL library for win32")
		ELSE(BORLAND)
			FIND_LIBRARY ( OPENGL_LIBRARIES OpenGL32
				PATHS "C:/Program Files/Microsoft Visual Studio 8/VC/PlatformSDK/Lib"
				      "C:/Program Files (x86)/Microsoft SDKs/Windows/v7.0A/Lib")
			FIND_PATH    ( OPENGL_INCLUDE_DIR gl/GL.h 
				PATHS "C:/Program Files/Microsoft Visual Studio 8/VC/PlatformSDK/Include"
				      "C:/Program Files (x86)/Microsoft SDKs/Windows/v7.0A/Include")
		ENDIF(BORLAND)
	ENDIF (CYGWIN)
ELSE (WIN32)
  IF (APPLE)
    FIND_LIBRARY(OPENGL_LIBRARIES OpenGL DOC "OpenGL lib for OSX")
    FIND_PATH(OPENGL_INCLUDE_DIR OpenGL/gl.h DOC "Include for OpenGL on OSX")
  ELSE(APPLE)
    FIND_PATH(OPENGL_INCLUDE_DIR GL/gl.h
      /usr/share/doc/NVIDIA_GLX-1.0/include
      /usr/openwin/share/include
      /opt/graphics/OpenGL/include /usr/X11R6/include
    )
    FIND_LIBRARY(OPENGL_LIBRARIES
      NAMES GL
      PATHS /opt/graphics/OpenGL/lib
            /usr/openwin/lib
            /usr/shlib /usr/X11R6/lib
    )
  ENDIF(APPLE)
ENDIF (WIN32)

IF(OPENGL_LIBRARIES)
    SET( OPENGL_FOUND "YES" )

	MESSAGE("OpenGL Desktop Library is found.")
	MESSAGE("OPENGL_LIBRARIES: "   ${OPENGL_LIBRARIES}   )
	MESSAGE("OPENGL_INCLUDE_DIR: " ${OPENGL_INCLUDE_DIR} )
ELSE(OPENGL_LIBRARIES)
	SET( OPENGL_FOUND "NO" )
	MESSAGE("OpenGL Desktop Library is not found.")
ENDIF(OPENGL_LIBRARIES)

MARK_AS_ADVANCED(
  OPENGL_INCLUDE_DIR
  OPENGL_LIBRARIES
)
