# - Try to find OpenGL ES
# Once done this will define
#  
#  OPENGLES2_0_FOUND        - system has OpenGL
#  OPENGLES2_0_INCLUDE_DIR  - the GL include directory
#  OPENGLES2_0_LIBRARIES    - Link these to use OpenGL

IF (WIN32)
	IF (CYGWIN)
		FIND_PATH    ( OPENGLES2_0_INCLUDE_DIR GLES2/gl2.h )
		FIND_LIBRARY ( OPENGLES2_0_LIBRARIES  libGLESv2  )
	ELSE (CYGWIN)
		IF(BORLAND)
			SET (OPENGLES2_0_LIBRARIES import32 CACHE STRING "OpenGL ES 2.0 library for win32")
		ELSE(BORLAND)
			FIND_LIBRARY ( OPENGLES2_0_LIBRARIES libGLESv2
				PATHS "C:/Program Files/Microsoft Visual Studio 8/VC/Lib"
				      "C:/Program Files/Microsoft Visual Studio 8/VC/PlatformSDK/Lib"
					   ${RENG_DEP_DIR}/lib
					  )
			FIND_PATH    ( OPENGLES2_0_INCLUDE_DIR GLES2/gl2.h 
				PATHS "C:/Program Files/Microsoft Visual Studio 8/VC/Include"
				      "C:/Program Files/Microsoft Visual Studio 8/VC/PlatformSDK/Include"
					   ${RENG_DEP_DIR}/include
					  )
		ENDIF(BORLAND)
	ENDIF (CYGWIN)
ELSE (WIN32)
  IF (APPLE)
	# not supported currently

  ELSE(APPLE)
    FIND_PATH    ( OPENGLES2_0_INCLUDE_DIR GLES2/gl2.h ) 
    FIND_LIBRARY ( OPENGLES2_0_LIBRARIES  GLESv2  )
  ENDIF(APPLE)
ENDIF (WIN32)

IF(OPENGLES2_0_LIBRARIES)
    SET( OPENGLES2_0_FOUND "YES" )

	MESSAGE("OpenGL ES Library is found.")
	MESSAGE("OPENGLES2_0_LIBRARIES: "   ${OPENGLES2_0_LIBRARIES}   )
	MESSAGE("OPENGLES2_0_INCLUDE_DIR: " ${OPENGLES2_0_INCLUDE_DIR} )

ELSE(OPENGLES2_0_LIBRARIES)
	SET( OPENGLES2_0_FOUND "NO" )
	MESSAGE("OpenGL ES Library is not found.")
ENDIF(OPENGLES2_0_LIBRARIES)

MARK_AS_ADVANCED(
  OPENGLES2_0_INCLUDE_DIR
  OPENGLES2_0_LIBRARIES
)
