" .material syntax file
" Language:	3dPhone REng .material file
" Maintainer:	Adil Yalcin <adil.yalcin@gmail.com>
" Last Change:	2009 Aug 23

" Quit when a (custom) syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

" TODO
	syn keyword matTodo             contained TODO FIXME XYZ
" COMMENT
	syn match   matComment          "//.*$" contains=matTodo,@Spell

" IDENTIFIERS
	" top-level blocks 
	syn keyword matID vertex_shader fragment_shader material texture
	" shader identifiers
	syn keyword matID source version uniform_defaults preproc_def preproc_undef preproc_set
	" texture identifiers
	syn keyword matID source type gen_mipmaps mag_filter min_filter wrap_mode 
	" material basic blocks
	syn keyword matID technique pass 
	syn keyword matID viewIndex lodIndex
	syn keyword matID vertex_shader_ref fragment_shader_ref render_states uniform_states texture_binding
	" generic render property identifiers
	syn keyword matID blending blend_equation blend_function 
	syn keyword matID stencil_test stencil_function stencil_mask stencil_operation 
	syn keyword matID depth_test depth_function depth_mask 
	syn keyword matID color_mask cull_face front_face poly_mode line_width
	syn keyword matID min_filter mag_filter wrap_mode 
	" texture binding identifiers
	syn keyword matID texture_name texture_unit

" INTEGER NUMBER
	syn match matNumber "\<\d\+\>"

" FLOATING NUMBER (with dot) 
	syn match matFloat  "\<\d\+\.\d*\>"

" CONSTANTS
	syn keyword matFuncMode   FUNC_ADD FUNC_SUBTRACT FUNC_REVERSE_SUBTRACT
	syn keyword matFuncMode_2 ZERO ONE SRC_COLOR ONE_MINUS_SRC_COLOR DST_COLOR ONE_MINUS_DST_COLOR 
	syn keyword matFuncMode_2 SRC_ALPHA ONE_MINUS_SRC_ALPHA DST_ALPHA ONE_MINUS_DST_ALPHA CONSTANT_COLOR
	syn keyword matFuncMode_2 ONE_MINUS_CONSTANT_COLOR CONSTANT_ALPHA ONE_MINUS_CONSTANT_ALPHA SRC_ALPHA_SATURATE
	syn keyword matFace       FRONT BACK FRONT_AND_BACK
	syn keyword matFunc       NEVER LESS LEQUAL GREATER GEQUAL EQUAL NOTEQUAL ALWAYS
	syn keyword matStencilOp  KEEP ZERO REPLACE INCR INCR_WRAP DECR DECR_WRAP INVERT
	syn keyword matFaceOri    CW CCW
	syn keyword matFillType   POINT FILL LINE
	syn keyword matFiltMag    NEAREST LINEAR
	syn keyword matFiltMin    NEAREST LINEAR NEAREST_MIPMAP_NEAREST LINEAR_MIPMAP_NEAREST NEAREST_MIPMAP_LINEAR LINEAR_MIPMAP_LINEAR
	syn keyword matWrapMode   REPEAT CLAMP_TO_EDGE MIRRORED_REPEAT CLAMP_TO_BORDER
	syn keyword matWrapAxis   AXIS_S AXIS_T AXIS_R
	syn keyword matTexType    1D 2D 3D CubeMap  

	syn keyword matUniType    float vec2 vec3 vec4 int ivec2 ivec3 ivec4 mat2 mat3 mat4
	syn keyword matBoolStr    on off

" Define the default highlighting.
if version >= 508 || !exists("did_lua_syntax_inits")
  if version < 508
    let did_lua_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

	" Link Constant groups
	HiLink matFuncMode   matConst
	HiLink matFuncMode_2 matConst
	HiLink matBoolStr    matConst
	HiLink matFace       matConst
	HiLink matFunc       matConst
	HiLink matStencilOp  matConst
	HiLink matFaceOri    matConst
	HiLink matFillType   matConst
	HiLink matFiltMag    matConst
	HiLink matFiltMin    matConst
	HiLink matWrapMode   matConst
	HiLink matWrapAxis   matConst
	HiLink matTexType    matConst

	HiLink matComment		Comment
	HiLink matConst      Constant
	HiLink matTodo       Todo
	HiLink matID         Identifier
	HiLink matNumber     Number
	HiLink matFloat      Float
	HiLink matUniType    Operator

	" UNUSED MAPPINGS
"  HiLink luaStatement		Statement
"  HiLink luaRepeat		Repeat
"  HiLink luaString		String
"  HiLink luaString2		String
"  HiLink luaCond		Conditional
"  HiLink luaFunction		Function
"  HiLink luaTable		Structure
"  HiLink luaError		Error

  delcommand HiLink
endif

let b:current_syntax = "material"

